﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
'Author: Brandsum
'Edited: MarcoRome
'Version: 1.41

#DesignerProperty: Key: TabCount, DisplayName: No. of Tabs, FieldType: String, DefaultValue: 6, List: 2|3|4|5|6, Description: Number of Tabs
#DesignerProperty: Key: CurrentTab, DisplayName: Focus Tab of Start, FieldType: String, DefaultValue: 1, List: 1|2|3|4|5|6, Description: Set Focus Tab of Start
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: BackGround color
#DesignerProperty: Key: ShadowColor, DisplayName: Shadow Color, FieldType: String, DefaultValue: Dark, List: Dark|Light, Description: Shadow Color
#DesignerProperty: Key: IconColor, DisplayName: Icon Color, FieldType: Color, DefaultValue: 0xFFBBBBBB, Description: Icon color
#DesignerProperty: Key: SelectedIconColor, DisplayName: Selected Icon Color, FieldType: Color, DefaultValue: 0xFF000000, Description: Selected Icon color
#DesignerProperty: Key: IconAppear, DisplayName: Icon Appear Style, FieldType: String, DefaultValue: EDGE, List: FROM EDGE|FROM CENTER|FADE IN|NO ANIMATION
#DesignerProperty: Key: AnimationType, DisplayName: Animation Type, FieldType: String, DefaultValue: ELASTIC OUT, List: ELASTIC OUT|ELASTIC IN|EASE OUT|EASE IN|NONE
#DesignerProperty: Key: AnimationDuration, DisplayName: Animation Duration, FieldType: Int, DefaultValue: 500, Description: Wobble animation time in milliseconds

#Event: Tab1Click
#Event: Tab2Click
#Event: Tab3Click
#Event: Tab4Click
#Event: Tab5Click
#Event: Tab6Click

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView
	Private xui As XUI
	
	Private BackgroundColor,IconColor,SelectedIconColor,circleRadius,animDuration As Int
	Private TabContainer,TabCurve,TabCircle,Tab1,Tab2,Tab3,Tab4,Tab5,Tab6 As B4XView
	Private Tabs,IconList As List
	Private MenuHeight, AbsoluteWidth, TabCount As Int
	Private CurrentTab As Int

	
	Public const ANIMATION_TYPE_ELASTIC_OUT As Int = 0
	Public const ANIMATION_TYPE_ELASTIC_IN As Int = 1
	Public const ANIMATION_TYPE_EASE_OUT As Int = 2
	Public const ANIMATION_TYPE_EASE_IN As Int = 3
	Public const ANIMATION_TYPE_NONE As Int = 4
	Private AnimationType As Int
	
	Public const ICON_APPEAR_FROM_CENTER As Int = 0
	Public const ICON_APPEAR_FROM_EDGE As Int = 1
	Public const ICON_APPEAR_FADE_IN As Int = 2
	Public const ICON_APPEAR_NO_ANIMATION As Int = 3
	Private IconAppearStyle As Int
	Private ShadowColor As String
	
	#IF B4J
	Dim fx As JFX
	#End If
	
	#IF B4A
	Type IconType(Icon As String, iFont As Typeface)
	#ELSE IF B4I OR B4J
	Type IconType(Icon As String, iFont As Font)
	#End If
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	IconList.Initialize
	Tabs.Initialize
	
End Sub

#Region Design
'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBase.Color = xui.Color_Transparent
	AbsoluteWidth= Min(mBase.Parent.Width,mBase.Parent.Height)
	MenuHeight = (AbsoluteWidth/7) + ((AbsoluteWidth/7)/4)
	mBase.Height = MenuHeight
	mBase.Top = mBase.Parent.Height - mBase.Height
	circleRadius = AbsoluteWidth/7
	
	BackgroundColor = xui.PaintOrColorToColor(Props.Get("BackgroundColor"))
	IconColor = xui.PaintOrColorToColor(Props.Get("IconColor"))
	SelectedIconColor = xui.PaintOrColorToColor(Props.Get("SelectedIconColor"))
	animDuration = Props.Get("AnimationDuration")
	TabCount = Props.Get("TabCount")
	ShadowColor = Props.Get("ShadowColor")
	CurrentTab = Props.Get("CurrentTab")
	If CurrentTab > TabCount Then
		Log($"*****Start Tab is > No. of Tabs******"$)
	End If
	
'	If TabCount = 5 Then
'		CurrentTab = 3
'	Else
'		CurrentTab = 1
'	End If
	
	Select Props.Get("IconAppear")
		Case "FROM EDGE": IconAppearStyle = ICON_APPEAR_FROM_EDGE
		Case "FROM CENTER": IconAppearStyle = ICON_APPEAR_FROM_CENTER
		Case "FADE IN": IconAppearStyle = ICON_APPEAR_FADE_IN
		Case "NO ANIMATION": IconAppearStyle = ICON_APPEAR_NO_ANIMATION
	End Select
	
	Select Props.Get("AnimationType")
		Case "ELASTIC OUT": AnimationType = ANIMATION_TYPE_ELASTIC_OUT
		Case "ELASTIC IN": AnimationType = ANIMATION_TYPE_ELASTIC_IN
		Case "EASE OUT": AnimationType = ANIMATION_TYPE_EASE_OUT
		Case "EASE IN": AnimationType = ANIMATION_TYPE_EASE_IN
		Case "NONE": AnimationType = ANIMATION_TYPE_NONE
	End Select
	
	DrawView

	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mBase.Width = Width
	AbsoluteWidth= Min(mBase.Parent.Width,mBase.Parent.Height)
	MenuHeight = (AbsoluteWidth/7) + ((AbsoluteWidth/7)/4)
	mBase.Height = MenuHeight
	mBase.Top = mBase.Parent.Height - mBase.Height
	circleRadius = AbsoluteWidth/7
	
	DrawView
End Sub

Private Sub DrawView
	mBase.RemoveAllViews
	Tabs.Clear
	If TabCircle.IsInitialized Then TabCircle.RemoveAllViews
	
	TabContainer = xui.CreatePanel("")
	mBase.AddView(TabContainer,0,mBase.Height/4 ,mBase.Width,mBase.Height - (mBase.Height/4))
	TabCurve = xui.CreatePanel("")
	TabContainer.AddView(TabCurve,((TabContainer.Width/TabCount)*(CurrentTab-1))+((TabContainer.Width/TabCount)/2)-((TabContainer.Width*2)/2),0,TabContainer.Width*2,TabContainer.Height)
	DrawCurve
	
	TabCircle = xui.CreatePanel("")
	mBase.AddView(TabCircle,((TabContainer.Width/TabCount)*(CurrentTab-1))+((TabContainer.Width/TabCount)/2) - (circleRadius/2),1dip,circleRadius,circleRadius)
	DrawCircle
	
	Dim icon As Label
	icon.Initialize("")
	
	#IF B4I
	icon.TextColor = SelectedIconColor
	icon.Font = Font.CreateFontAwesome(22)
	icon.TextAlignment = icon.ALIGNMENT_CENTER
	#ELSE IF B4A
	icon.TextColor = SelectedIconColor
	icon.Typeface = Typeface.FONTAWESOME
	icon.TextSize = 22
	icon.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	#ELSE IF B4J
	icon.TextColor = fx.Colors.From32Bit(SelectedIconColor)
	icon.Font = fx.CreateFontAwesome(22)
	icon.Alignment = "CENTER"
	#End If
	
	TabCircle.AddView(icon,0,0,TabCircle.Width,TabCircle.Height)
	
	Dim lw,rw,cw As B4XView
	lw = xui.CreatePanel("")
	rw = xui.CreatePanel("")
	cw = xui.CreatePanel("")
	lw.Color = BackgroundColor
	rw.Color = BackgroundColor
	cw.Color = BackgroundColor
	TabCircle.AddView(lw,(TabCircle.Height/5),(TabCircle.Height/2)-((TabCircle.Height/2)/2),1dip,TabCircle.Height/2)
	TabCircle.AddView(rw,TabCircle.Width-(TabCircle.Height/5) - 1dip,(TabCircle.Height/2)-((TabCircle.Height/2)/2),1dip,TabCircle.Height/2)
	TabCircle.AddView(cw,TabCircle.Width/2,(TabCircle.Height/2)-((TabCircle.Height/2)/2),0,TabCircle.Height/2)
	
	Tab1 = xui.CreatePanel("IconTab")
	Tabs.Add(Tab1)
	Tab2 = xui.CreatePanel("IconTab")
	Tabs.Add(Tab2)
	Tab3 = xui.CreatePanel("IconTab")
	Tabs.Add(Tab3)
	Tab4 = xui.CreatePanel("IconTab")
	Tabs.Add(Tab4)
	Tab5 = xui.CreatePanel("IconTab")
	Tabs.Add(Tab5)
	Tab6 = xui.CreatePanel("IconTab")
	Tabs.Add(Tab6)
	
	CreateTab(Tabs)
	SetCircleIcon
End Sub

Private Sub CreateTab(tabList As List)
	For j=0 To TabCount-1
		
		Dim tabView As B4XView = tabList.Get(j)
		Dim tab_width As Int = TabContainer.Width/TabCount
		tabView.Color = xui.Color_Transparent
		TabContainer.AddView(tabView,tab_width*j,0,tab_width,TabContainer.Height)
		
		Dim icon As Label
		icon.Initialize("")
		#IF B4A or B4I
		icon.TextColor = IconColor
		#ELSE IF B4J
		icon.TextColor = fx.Colors.From32Bit(IconColor)
		#End If
		
		Dim i As IconType:i.Initialize
		If IconList.size > j Then
			i = IconList.Get(j)
		Else
			i.icon = Chr(0xF10C)
			#IF B4I
			i.ifont = Font.CreateFontAwesome(20)
			#ELSE IF B4J
			i.ifont = fx.CreateFontAwesome(20)
			#ELSE IF B4A
			i.ifont = Typeface.FONTAWESOME
			#End If
		End If
		
		
		#IF B4I
		icon.Font = i.iFont
		icon.TextAlignment = icon.ALIGNMENT_CENTER
		#ELSE IF B4A
		icon.TextSize = 20
		icon.Typeface = i.iFont
		icon.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
		#ELSE IF B4J
		icon.TextSize = 20
		icon.Font = i.iFont
		icon.Alignment = "CENTER"
		#End If
		
		icon.Text = i.icon
		tabView.AddView(icon,0,0,tabView.Width,tabView.Height)
		
		If IconList.Size < TabCount Then IconList.add(i)
		If j=CurrentTab-1 Then icon.Visible = False
	Next
End Sub

Private Sub SetCircleIcon
	#IF B4A OR B4I
	Dim id As Int = 0
	#ELSE IF B4J
	Dim id As Int = 1
	#End If
	
	Select IconAppearStyle
		Case 0:
			TabCircle.GetView(id+1).SetLayoutAnimated(0,TabCircle.GetView(id+1).Left,TabCircle.GetView(id+1).Top,TabCircle.Width/2,TabCircle.GetView(id+1).Height)
			TabCircle.GetView(id+2).SetLayoutAnimated(0,TabCircle.Width-(TabCircle.Height/5) - (TabCircle.Width/2),TabCircle.GetView(2).Top,TabCircle.Width/2,TabCircle.GetView(2).Height)
			TabCircle.GetView(id+1).SetVisibleAnimated(0,True)
			TabCircle.GetView(id+2).SetVisibleAnimated(0,True)
		Case 1:
			TabCircle.GetView(id+3).SetLayoutAnimated(0,TabCircle.GetView(id+1).left,TabCircle.GetView(id+1).Top,TabCircle.GetView(id+2).Left-TabCircle.GetView(id+1).Left,TabCircle.GetView(id+1).Height)
			TabCircle.GetView(id+3).SetVisibleAnimated(0,True)
		Case 2:
			TabCircle.GetView(id).SetVisibleAnimated(0,False)
	End Select
	Sleep(1)
	
	Dim cl As Label = TabCircle.GetView(id)
	Dim mTab As B4XView = Tabs.Get(CurrentTab-1)
	Dim tl As Label = mTab.GetView(0)
	cl.Text = tl.text
	
	#IF B4I
	cl.Font = Font.CreateNew2(tl.Font.Name,24)
	#ELSE IF B4J
	cl.Font = fx.CreateFont(tl.Font.FamilyName,24,False,False)
	#ELSE IF B4A
	cl.Typeface = tl.Typeface
	#End If
	
	Select IconAppearStyle
		Case 0:
			TabCircle.GetView(id+1).SetLayoutAnimated(800,TabCircle.GetView(id+1).Left,TabCircle.GetView(id+1).Top,1dip,TabCircle.GetView(id+1).Height)
			TabCircle.GetView(id+2).SetLayoutAnimated(800,TabCircle.Width-(TabCircle.Height/4) - 1dip,TabCircle.GetView(id+2).Top,1dip,TabCircle.GetView(id+2).Height)
		Case 1:
			TabCircle.GetView(id+3).SetLayoutAnimated(800,TabCircle.Width/2,TabCircle.GetView(id+1).Top,1dip,TabCircle.GetView(id+1).Height)
		Case 2:
			TabCircle.GetView(id).SetVisibleAnimated(800,True)
	End Select
	
	#IF B4A
	Sleep(400)
	#ELSE B4I OR B4J
		Sleep(700)
	#End If
	TabCircle.GetView(id+1).SetVisibleAnimated(100,False)
	TabCircle.GetView(id+2).SetVisibleAnimated(100,False)
	TabCircle.GetView(id+3).SetVisibleAnimated(100,False)
	
End Sub

Private Sub DrawCurve
	Dim backARGB() As Int = GetARGB(BackgroundColor)
	Dim curve As B4XCanvas
	curve.Initialize(TabCurve)
	Dim rect As B4XRect
	Dim BezierView As BitmapCreator
	Dim BezierPath As BCPath
	Dim sWidth As Double = 1000
	Dim sHeight As Double = 500
	#IF B4A
	Dim curveHeight As Double = sHeight- sHeight/5 - 5
	#ELSE IF B4I OR B4J
	Dim curveHeight As Double = sHeight- sHeight/5
	#End If
	
	
	BezierPath.Initialize(0, 0)
	CurveTo(BezierPath, sWidth/8 - 3, 0, sWidth/7, (sHeight/3))
	CurveTo(BezierPath, sWidth/5 + 10, curveHeight , sWidth/2, curveHeight )
	CurveTo(BezierPath, sWidth-(sWidth/5 + 10), curveHeight , sWidth-(sWidth/7), (sHeight/3))
	CurveTo(BezierPath, sWidth-(sWidth/8 - 3), 0, sWidth, 0)
	BezierPath.LineTo(sWidth,sHeight)
	BezierPath.LineTo(0,sHeight)
	BezierPath.LineTo(0,0)
	
	Dim shadow As Int
	If ShadowColor="Dark" Then
		shadow = xui.Color_ARGB(backARGB(0),Max(0,backARGB(1)-20),Max(0,backARGB(2)-20),Max(0,backARGB(3)-20))
	Else If ShadowColor="Light" Then
		shadow = xui.Color_ARGB(backARGB(0),Min(255,backARGB(1)+20),Min(255,backARGB(2)+20),Min(255,backARGB(3)+20))
	End If
	
	BezierView.Initialize(sWidth,sHeight)
	BezierView.DrawPath(BezierPath,BackgroundColor,True,0)
	#IF B4A 
	BezierView.DrawPath(BezierPath,shadow,False,10)
	#ELSE IF B4I OR B4J
	BezierView.DrawPath(BezierPath,shadow,False,20)
	#End If
	
	rect.Initialize(TabContainer.Width - (AbsoluteWidth/5)/2 -4,0,TabContainer.Width + (AbsoluteWidth/5)/2+4,TabContainer.Height)
	curve.DrawBitmap(BezierView.Bitmap,rect)

	rect.Initialize(0,0,TabContainer.Width -(AbsoluteWidth/5)/2,TabContainer.Height)
	curve.DrawRect(rect,BackgroundColor,True,0)
	rect.Initialize(TabContainer.Width +(AbsoluteWidth/5)/2  ,0,TabCurve.Width,TabContainer.Height)
	curve.DrawRect(rect,BackgroundColor,True,0)
	curve.DrawLine(0,0,TabContainer.Width -(AbsoluteWidth/5)/2,0,shadow,4)
	curve.DrawLine(TabContainer.Width +(AbsoluteWidth/5)/2,0,TabContainer.Width*2,0,shadow,4)
	curve.DrawLine(0,TabContainer.Height,TabContainer.Width*2,TabContainer.Height,BackgroundColor,4)
	
	curve.Invalidate
End Sub

Private Sub DrawCircle
	Dim circle As B4XCanvas
	circle.Initialize(TabCircle)
	Dim innerRadius As Int = Min(mBase.Parent.Width,mBase.Parent.Height)/8
	For i=1 To 10
		If ShadowColor="Dark" Then
			circle.DrawCircle(circleRadius/2,(circleRadius/2)+2,(innerRadius/2)+i,xui.Color_ARGB(3,0,0,0),True,0)
		Else If ShadowColor="Light" Then
			circle.DrawCircle(circleRadius/2,(circleRadius/2)+2,(innerRadius/2)+i,xui.Color_ARGB(3,255,255,255),True,0)
		End If
		
	Next
	circle.DrawCircle(circleRadius/2,circleRadius/2,innerRadius/2,BackgroundColor,True,0)
	circle.Invalidate
End Sub

#End Region

#Region UserFunctions

#IF B4I OR B4J
Public Sub SetTabIcon(TabID As Int,Icon As String, IconFont As Font)
#ELSE IF B4A
Public Sub SetTabIcon(TabID As Int,Icon As String, IconFont As Typeface)
#End If
	If TabID >= 1 And TabID <= TabCount Then
		Dim i As IconType:i.Initialize
		i.icon = Icon
		i.ifont = IconFont
		IconList.set(TabID-1,i)
		
		Dim mTab As B4XView = Tabs.Get(TabID-1)
		Dim l As Label = mTab.GetView(0)
		l.Text = Icon
		#IF B4I
		l.Font = Font.CreateNew2(IconFont.Name,20)
		#ELSE IF B4J
		l.Font = fx.CreateFont(IconFont.FamilyName,20,False,False)
		#ELSE IF B4A
		l.Typeface = IconFont
		#End If
		
		SetCircleIcon
	Else
		Log("Invalid Tab ID")
	End If
End Sub

Public Sub GetCurrentTab As Int
	Return CurrentTab
End Sub

Public Sub SetCurrentTab(TabID As Int)
	If TabID >= 1 And TabID <= TabCount Then
		TriggerTabClickEvent(Tabs.Get(TabID-1))
	Else
		Log("Invalid Tab ID")
	End If
End Sub

Public Sub SetAnimationType(Animation_Type As Int)
	AnimationType = Animation_Type
End Sub

Public Sub SetIconAppearStyle(Icon_Appear_Style As Int)
	IconAppearStyle = Icon_Appear_Style
End Sub

#End Region

#Region EventHandling

#If B4J

Private Sub IconTab_MouseClicked (EventData As MouseEvent)
	TriggerTabClickEvent(Sender)
End Sub

#Else

Private Sub IconTab_Click
	TriggerTabClickEvent(Sender)
End Sub

#End If

Private Sub TriggerTabClickEvent(t As B4XView)
	If CurrentTab = Tabs.IndexOf(t)+1 Then Return
	CurrentTab = Tabs.IndexOf(t)+1
	AnimateTo(TabCurve,t.Left+(t.Width/2)-(TabCurve.Width/2) - 1 )
	AnimateTo(TabCircle,t.Left+(t.Width/2)-(TabCircle.Width/2))
	
	For i=0 To TabCount-1
		Dim tb As B4XView = Tabs.Get(i)
		If tb<>t Then
			tb.GetView(0).SetVisibleAnimated(1,True)
		Else
			tb.GetView(0).SetVisibleAnimated(300,False)
		End If
	Next
	SetCircleIcon
	
	If xui.SubExists(mCallBack, mEventName & "_Tab"&CurrentTab&"Click",0) Then
		CallSub(mCallBack, mEventName & "_Tab"&CurrentTab&"Click")
	End If
End Sub

#End Region

#Region Functions

Private Sub AnimateTo(Element As B4XView,NewPos As Int)
	Dim n As Long = DateTime.Now
	Dim duration As Int = animDuration
	Dim currentPos As Int = Element.left
	Dim start As Float = currentPos
	currentPos = NewPos
	Dim tempValue As Float
	Do While DateTime.Now < n + duration
		tempValue = TimeWisePosition(DateTime.Now - n, start, NewPos - start, duration)
		Element.left=tempValue
		Sleep(1)
		If NewPos <> currentPos Then Return
	Loop
	Element.Left = currentPos
End Sub

'http://www.timotheegroleau.com/Flash/experiments/easing_function_generator.htms
Private Sub TimeWisePosition(ctime As Float, fromPos As Float, toPos As Float, duration As Int) As Int
	Dim ts,tc As Float
	ctime = ctime/duration
	ts=ctime*ctime
	tc=ts*ctime
	
	Select AnimationType
		Case 0: 'elastic out
			Return fromPos + toPos * (23.645*tc*ts + -73.7325*ts*ts + 86.38*tc + -46.79*ts + 11.4975*ctime)
		Case 1: 'elastic in
			Return fromPos + toPos * (34.445*tc*ts + -69.39*ts*ts + 47.395*tc + -12.4*ts + 0.95*ctime)
		Case 2: 'ease out
			Return fromPos + toPos * (tc*ts + -5*ts*ts + 10*tc + -10*ts + 5*ctime)
		Case 3: 'ease in
			Return fromPos + toPos * (tc*ts)
		Case Else: 'no easing
			Return fromPos + toPos*(ctime)
	End Select
	
End Sub

'Curve function 
Private Sub CurveTo (Path1 As BCPath, ControlPointX As Float, ControlPointY As Float, TargetX As Float, TargetY As Float)
	Dim LastPoint As InternalBCPathPointData = Path1.Points.Get(Path1.Points.Size - 1)
	Dim CurrentX As Float = LastPoint.X
	Dim Currenty As Float = LastPoint.Y
	Dim NumberOfSteps As Int = 11 '<--- change as needed
	Dim dt As Float = 1 / NumberOfSteps
	Dim t As Float = dt
	For i = 1 To NumberOfSteps
		Dim tt1 As Float =  (1 - t) * (1 - t)
		Dim tt2 As Float = 2 * (1 - t) * t
		Dim tt3 As Float = t * t
		Dim x As Float = tt1 * CurrentX + tt2 * ControlPointX + tt3 * TargetX
		Dim y As Float = tt1 * Currenty + tt2 * ControlPointY + tt3 * TargetY
		Path1.LineTo(x, y)
		t = t + dt
	Next
End Sub

'int ot argb
Private Sub GetARGB(Color As Int) As Int()
	Private res(4) As Int
	res(0) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff000000), 24)
	res(1) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff0000), 16)
	res(2) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff00), 8)
	res(3) = Bit.And(Color, 0xff)
	Return res
End Sub

#End Region